Bug 14146 - sgen-only test failures in mono/tests/gc-altstack.exe
Summary: sgen-only test failures in mono/tests/gc-altstack.exe
Status: RESOLVED FIXED
Alias: None
Product: Runtime
Classification: Mono
Component: GC (show other bugs)
Version: unspecified
Hardware: PC Linux
: --- normal
Target Milestone: ---
Assignee: Bugzilla
URL:
Depends on:
Blocks:
 
Reported: 2013-08-21 11:09 UTC by Charles Randall
Modified: 2013-10-02 16:52 UTC (History)
4 users (show)

Tags:
Is this bug a regression?: ---
Last known good build:

Notice (2018-05-24): bugzilla.xamarin.com is now in read-only mode.

Please join us on Visual Studio Developer Community and in the Xamarin and Mono organizations on GitHub to continue tracking issues. Bugzilla will remain available for reference in read-only mode. We will continue to work on open Bugzilla bugs, copy them to the new locations as needed for follow-up, and add the new items under Related Links.

Our sincere thanks to everyone who has contributed on this bug tracker over the years. Thanks also for your understanding as we make these adjustments and improvements for the future.


Please create a new report on GitHub or Developer Community with your current version information, steps to reproduce, and relevant error messages or log files if you are hitting an issue that looks similar to this resolved bug and you do not yet see a matching new report.

Related Links:
Status:
RESOLVED FIXED

Description Charles Randall 2013-08-21 11:09:20 UTC
Running on OpenSuse 12.3/x86_64 with git master from today at d71ca46641a6cb7feffb471f86673451f434dda2.

I have disabled all AOT at configure time to work around other problems. Exact build steps are,

  make clean
  git pull
  ./autogen.sh --prefix=/tmp/mono-master
  ./configure --prefix=/tmp/mono-master --enable-minimal=aot --disable-system-aot
  make -j 4
  make install

The resulting mono is,

# mono --version
Mono JIT compiler version 3.3.0 (master/d71ca46 Wed Aug 21 08:41:07 MDT 2013)
Copyright (C) 2002-2012 Novell, Inc, Xamarin Inc and Contributors. www.mono-project.com
        TLS:           __thread
        SIGSEGV:       altstack
        Notifications: epoll
        Architecture:  amd64
        Disabled:      aot
        Misc:          softdebug
        LLVM:          supported, not enabled.
        GC:            sgen


The test mono/tests/gc-altstack.exe fails ~1% of the time with no meaningful output. To reproduce the problem,

# i=0; while mono ./gc-altstack.exe; do i=`expr $i + 1`; echo $i -----; done
..........
..........
1 -----
...snip...
27 -----
..........
Stacktrace:


Native stacktrace:

Segmentation fault

This is not reducible with --gc=boehm in a few thousand iterations.

Side note... Don't know if it's interesting or not but this test runs significantly faster using the boehm gc instead of sgen.
Comment 1 Charles Randall 2013-08-21 11:17:40 UTC
As a double-check that AOT is really disabled, this test still fails with "-O=-aot".

# i=0; while mono -O=-aot ./gc-altstack.exe; do i=`expr $i + 1`; echo $i -----; done
...
360 -----
..........
.Stacktrace:


Native stacktrace:

Segmentation fault
Comment 2 Mark Probst 2013-10-02 16:52:43 UTC
Fixed in 8828fafe297e758858468c2e96054ae101ea7227.